
##### install thepackage

install.packages("AER") # only the first time

##### upload the library

library(AER)

##### 

data("CASchools")

str(CASchools)

head(CASchools)

dim(CASchools)

?CASchools

###### calculate the score e the student/teacher ratio

CASchools$stratio <- with(CASchools, students/teachers)
CASchools$score <- with(CASchools, (math + read)/2)

###### statistics

stat_stratio<-c(mean(CASchools$stratio),
                sd(CASchools$stratio),
                quantile(CASchools$stratio,c(0.10,0.25,0.4,0.5,0.6,0.75,0.9)))

stat_stratio<-t(as.matrix(stat_stratio))

colnames(stat_stratio)[c(1:2)]<-c("mean","sd")

round(stat_stratio,1)

###### Calculate the score per class
###### small and large

sub_small_class<-subset(CASchools,
                        CASchools$stratio<20)

sub_large_class<-subset(CASchools,
                        CASchools$stratio>=20)

small_class_score<-
  cbind(mean(sub_small_class$score),sd(sub_small_class$score),
        nrow(sub_small_class))

colnames(small_class_score)<-c("Mean","SD","n")

round(small_class_score,2)

large_class_score<-cbind(mean(sub_large_class$score),sd(sub_large_class$score),
                         nrow(sub_large_class))

colnames(large_class_score)<-c("Mean","SD","n")

round(large_class_score,2)

tab<-rbind(small_class_score,large_class_score)

rownames(tab)<-c("STR<20","STR>=20")
round(tab,3)


####### Plot

plot(CASchools$stratio,CASchools$score,pch=19,xlim=c(10,30),
     ylim=c(600,720))

cor(CASchools$score,CASchools$stratio)

####### regression with lm

reg_1 <- lm(score ~ stratio, data = CASchools)
summary(reg_1)

abline(reg_1,col="red")

####### regressione "with calculation"

## beta_1

beta_1_hat<-cov(CASchools$score,CASchools$stratio)/var(CASchools$stratio)
round(beta_1_hat,4)

## beta_0
beta_0_hat<-mean(CASchools$score)-beta_1_hat*mean(CASchools$stratio)
round(beta_0_hat,4)

####### R2

summary(reg_1)

head(fitted(reg_1))
head(residuals(reg_1))

# R^2=ESS/TSS=1-RSS/TSS

TSS<-sum( (CASchools$score - mean(CASchools$score))^2 )
ESS<-sum( (fitted(reg_1) - mean(CASchools$score))^2 )
RSS<-sum(residuals(reg_1)^2)

ESS/TSS

1-RSS/TSS

####### SER 

n<-nrow(CASchools)

sqrt(sum(residuals(reg_1)^2)/(n-2))